/* -*-c-*-
 *
 * Manipulates flags on file descriptors
 *
 * (c) 1999 Straylight/Edgeware
 */

/*----- Licensing notice --------------------------------------------------*
 *
 * This file is part of the mLib utilities library.
 *
 * mLib is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * mLib is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with mLib; if not, write to the Free
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 */

#ifndef MLIB_FDFLAGS_H
#define MLIB_FDFLAGS_H

#ifdef __cplusplus
  extern "C" {
#endif

/*----- Header files ------------------------------------------------------*/

#include <fcntl.h>

/*----- Magic numbers -----------------------------------------------------*/

#ifndef FD_CLOEXEC
#  define FD_CLOEXEC 1
#endif

/*----- Functions provided ------------------------------------------------*/

/* --- @fdflags@ --- *
 *
 * Arguments:	@int fd@ = file descriptor to fiddle with
 *		@unsigned fbic, fxor@ = file flags to set and clear
 *		@unsigned fdbic, fdxor@ = descriptor flags to set and clear
 *
 * Returns:	Zero if successful.
 *
 * Use:		Sets file descriptor flags.
 */

int fdflags(int /*fd*/, unsigned /*fbic*/, unsigned /*fxor*/,
	    unsigned /*fdbic*/, unsigned /*fdxor*/);

/*----- That's all, folks -------------------------------------------------*/

#ifdef __cplusplus
  }
#endif

#endif
